package ru.sicamp.sicamphelper.api.command.impl

import org.springframework.stereotype.Component
import ru.sicamp.sicamphelper.api.command.Commands
import ru.sicamp.sicamphelper.api.command.PublicCommand
import ru.sicamp.sicamphelper.api.command.getValueOrNull
import ru.sicamp.sicamphelper.model.request.RequestWrapper
import ru.sicamp.sicamphelper.model.data.UserInput
import ru.sicamp.sicamphelper.model.request.info.InfoRequest
import ru.sicamp.sicamphelper.model.response.info.InfoResponse
import ru.sicamp.sicamphelper.service.InfoService
import ru.sicamp.sicamphelper.service.UserService

@Component
class InfoCommand(
    override val userService: UserService,
    private val infoService: InfoService
) : PublicCommand<InfoRequest, InfoResponse>(Commands.INFO) {
    override suspend fun executeRequest(request: RequestWrapper<InfoRequest>) = infoService.getInfo(request)

    override fun extract(
        arguments: Array<out String>?
    ) = InfoRequest(
        userInput = arguments?.getValueOrNull(0)?.let {
            UserInput(it)
        }
    )
}
