package ru.sicamp.sicamphelper.db.table

import org.jetbrains.exposed.dao.id.LongIdTable
import org.jetbrains.exposed.sql.javatime.date
import org.jetbrains.exposed.sql.javatime.duration
import org.jetbrains.exposed.sql.javatime.time
import ru.sicamp.sicamphelper.CUSTOM_TEXT_SIZE

object Events : LongIdTable("events") {
    val name = varchar("name", 255)
    val type = enumerationByName<Type>("type", 255)
    val registrationType = enumerationByName<RegistrationType>("registration_type", 255)
    val group = reference("group", Groups).nullable()
    val eventDate = date("event_date").nullable()
    val eventTime = time("event_time")
    /**Should be in days*/
    val repeat = duration("repeat").nullable()
    val assigneeCount = integer("assignee_count").nullable()
    val status = enumerationByName<Status>("status", 255)
    val description = varchar("description", CUSTOM_TEXT_SIZE)
    val responsible = reference("responsible", Users)
    val defaultRoom = reference("default_room", Rooms).nullable()

    enum class Type { ONCE, REGULAR }
    enum class RegistrationType { ALL, GROUP, USER }
    enum class Status { SCHEDULE, SKIP_ONCE, DISABLED }
}