package ru.sicamp.sicamphelper.db.table

import org.jetbrains.exposed.dao.id.LongIdTable
import org.jetbrains.exposed.sql.javatime.datetime
import ru.sicamp.sicamphelper.CUSTOM_TEXT_SIZE

object Schedules : LongIdTable("schedules") {
    val start = datetime("start").index("datetime_index")
    val end = datetime("end")
    val description = varchar("description", CUSTOM_TEXT_SIZE).nullable()
    val responsible = reference("responsible", Users)
    val event = reference("event", Events).index("event_index")
    val room = reference("room", Rooms).nullable()

    val eventStartIdx = index("event_start_idx", isUnique = true, event, start)
}